<template>
  <n-modal v-model:show="modalVisible" preset="card" :title="title" class="w-700px">
    <n-form ref="formRef" label-placement="left" :label-width="100" :model="formModel" :rules="rules">
      <n-grid :cols="24" :x-gap="18">
        <n-form-item-grid-item :span="12" label="学科名称" path="name">
          <n-input v-model:value="formModel.name" clearable />
        </n-form-item-grid-item>
        <n-form-item-grid-item :span="12" label="学科描述" path="description">
          <n-input v-model:value="formModel.description" clearable />
        </n-form-item-grid-item>
        <n-form-item-grid-item :span="12" label="创建用户ID" path="createUid">
          <n-input-number v-model:value="formModel.createUid" />
        </n-form-item-grid-item>
        <n-form-item-grid-item :span="12" label="状态" path="disabled">
          <n-select v-model:value="formModel.disabled" :options="userStatusOptions" />
        </n-form-item-grid-item>
      </n-grid>
      <n-space class="w-full pt-16px" :size="24" justify="end">
        <n-button class="w-72px" @click="closeModal">取消</n-button>
        <n-button class="w-72px" type="primary" @click="handleSubmit">确定</n-button>
      </n-space>
    </n-form>
  </n-modal>
</template>

<script setup lang="ts">
import { ref, computed, reactive, watch } from 'vue';
import type { FormInst, FormItemRule } from 'naive-ui';
import { userStatusOptions } from '@/constants';
import { createRequiredFormRule } from '@/utils';
import type { AddEasEduCategoryParams } from '~/src/service/api/sort';
import { addEasEduCategory } from '~/src/service/api/sort';

export interface Props {
  /** 弹窗可见性 */
  visible: boolean;
  /**
   * 弹窗类型
   * add: 新增
   * edit: 编辑
   */
  type?: 'add' | 'edit';
  /** 编辑的表格行数据 */
  editData?: UserManagement.User | null;
}

export type ModalType = NonNullable<Props['type']>;

defineOptions({ name: 'TableActionAdd' });

const props = withDefaults(defineProps<Props>(), {
  type: 'add',
  editData: null
});

interface Emits {
  (e: 'update:visible', visible: boolean): void;
}
const emit = defineEmits<Emits>();

const modalVisible = computed({
  get() {
    return props.visible;
  },
  set(visible) {
    emit('update:visible', visible);
  }
});
const closeModal = () => {
  modalVisible.value = false;
};

const title = computed(() => {
  const titles: Record<ModalType, string> = {
    add: '添加用户',
    edit: '编辑用户'
  };
  return titles[props.type];
});

const formRef = ref<HTMLElement & FormInst>();

type FormModel = Pick<UserManagement.User, 'name' | 'description' | 'createUid' | 'disabled'>;

const formModel = reactive<FormModel>(createDefaultFormModel());

const rules: Record<keyof FormModel, FormItemRule | FormItemRule[]> = {
  name: createRequiredFormRule('请输入学科名称'),
  description: createRequiredFormRule('请进行部门描述'),
  createUid: createRequiredFormRule('请输入创建用户ID'),
  disabled: createRequiredFormRule('请选择用户状态')
};
function createDefaultFormModel(): FormModel {
  return {
    name: '',
    description: '',
    createUid: null,
    disabled: null
  };
}

function handleUpdateFormModel(model: Partial<FormModel>) {
  Object.assign(formModel, model);
}

function handleUpdateFormModelByModalType() {
  const handlers: Record<ModalType, () => void> = {
    add: () => {
      const defaultFormModel = createDefaultFormModel();
      handleUpdateFormModel(defaultFormModel);
    },
    edit: () => {
      if (props.editData) {
        handleUpdateFormModel(props.editData);
      }
    }
  };
  handlers[props.type]();
}

async function handleSubmit() {
  await formRef.value?.validate();
  const params: AddEasEduCategoryParams = {
    name: formModel.name,
    description: formModel.description,
    createUid: formModel.createUid,
    disabled: formModel.disabled
  };
  addEasEduCategory(params)
    .then(() => {
      window.$message?.success('新增成功!');
      closeModal();
    })
    .catch(() => {
      window.$message?.error('新增失败!');
    });
}
watch(
  () => props.visible,
  newValue => {
    if (newValue) {
      handleUpdateFormModelByModalType();
    }
  }
);
</script>
<style scoped></style>
